using System;
using System.Configuration;
using System.Net;
using System.Security.Cryptography;

public partial class CyberSourceCS : System.Web.UI.Page
{
    private String getMerchantID()
    {
        //insert your own value
        return "";
    }

    private String getPublicKey()
    {
        //insert your own value
        return "";
    }

    private String getSerialNumber()
    {
        //insert your own value
        return "";
    }
    
    //method deprecated
    public void insertSignature(String amount, String currency)
    {
        insertSignature3(amount, currency, "authorization");
    }

    public void insertSignature3(String amount, String currency, String orderPage_transactionType)
    {
        try
        {
            TimeSpan timeSpanTime = DateTime.UtcNow - new DateTime(1970, 1, 1);
            String[] arrayTime = timeSpanTime.TotalMilliseconds.ToString().Split('.');
            String time = arrayTime[0];
            String merchantID = getMerchantID();
            if (merchantID.Equals(""))
                Response.Write("<b>Error:</b> <br>The current security script (HOP.cs) doesn't contain your merchant information. Please login to the <a href='https://ebc.cybersource.com/ebc/hop/HOPSecurityLoad.do'>CyberSource Business Center</a> and generate one before proceeding further. Be sure to replace the existing HOP.cs with the newly generated HOP.cs.<br><br>");
            String data = merchantID + amount + currency + time + orderPage_transactionType;
            String pub = getPublicKey();
            String serialNumber = getSerialNumber();
            byte[] byteData = System.Text.Encoding.UTF8.GetBytes(data);
            byte[] byteKey = System.Text.Encoding.UTF8.GetBytes(pub);
            HMACSHA1 hmac = new HMACSHA1(byteKey);
            String publicDigest = Convert.ToBase64String(hmac.ComputeHash(byteData));
            publicDigest = publicDigest.Replace("\n", "");
            System.Text.StringBuilder sb = new System.Text.StringBuilder();            
            sb.Append("<input type=\"hidden\" name=\"amount\" value=\"");
            sb.Append(amount);
            sb.Append("\">\n<input type=\"hidden\" name=\"currency\" value=\"");
            sb.Append(currency);
            sb.Append("\">\n<input type=\"hidden\" name=\"orderPage_timestamp\" value=\"");
            sb.Append(time);
            sb.Append("\">\n<input type=\"hidden\" name=\"merchantID\" value=\"");
            sb.Append(merchantID);
            sb.Append("\">\n<input type=\"hidden\" name=\"orderPage_transactionType\" value=\"");
            sb.Append(orderPage_transactionType);
            sb.Append("\">\n<input type=\"hidden\" name=\"orderPage_signaturePublic\" value=\"");
            sb.Append(publicDigest);
            sb.Append("\">\n<input type=\"hidden\" name=\"orderPage_version\" value=\"4\">\n");
            sb.Append("<input type=\"hidden\" name=\"orderPage_serialNumber\" value=\"");
            sb.Append(serialNumber);
            sb.Append("\">\n");
            Response.Write(sb.ToString());
        }
        catch (Exception e)
        {
            Response.Write(e.StackTrace.ToString());
        }
    }
    public void insertSubscriptionSignature(String subscriptionAmount, String subscriptionStartDate, String subscriptionFrequency, String subscriptionNumberOfPayments, String subscriptionAutomaticRenew)
    {
        try {
            String data = subscriptionAmount + subscriptionStartDate + subscriptionFrequency + subscriptionNumberOfPayments + subscriptionAutomaticRenew;
            String pub = getPublicKey();
            byte[] byteData = System.Text.Encoding.UTF8.GetBytes(data);
            byte[] byteKey = System.Text.Encoding.UTF8.GetBytes(pub);
            HMACSHA1 hmac = new HMACSHA1(byteKey);
            String publicDigest = Convert.ToBase64String(hmac.ComputeHash(byteData));
            publicDigest = publicDigest.Replace("\n", "");
            System.Text.StringBuilder sb = new System.Text.StringBuilder();            
            sb.Append("<input type=\"hidden\" name=\"recurringSubscriptionInfo_amount\" value=\"");
            sb.Append(subscriptionAmount);
            sb.Append("\">\n<input type=\"hidden\" name=\"recurringSubscriptionInfo_numberOfPayments\" value=\"");
            sb.Append(subscriptionNumberOfPayments);
            sb.Append("\">\n<input type=\"hidden\" name=\"recurringSubscriptionInfo_frequency\" value=\"");
            sb.Append(subscriptionFrequency);
            sb.Append("\">\n<input type=\"hidden\" name=\"recurringSubscriptionInfo_automaticRenew\" value=\"");
            sb.Append(subscriptionAutomaticRenew);
            sb.Append("\">\n<input type=\"hidden\" name=\"recurringSubscriptionInfo_startDate\" value=\"");
            sb.Append(subscriptionStartDate);
            sb.Append("\">\n<input type=\"hidden\" name=\"recurringSubscriptionInfo_signaturePublic\" value=\"");
            sb.Append(publicDigest);
            sb.Append("\">\n");
            Response.Write(sb.ToString());
        } 
        catch (Exception e) {
            Response.Write(e.StackTrace.ToString());
        }
    }
    public void insertSubscriptionIDSignature(String subscriptionID)
    {
        try
        {
            String pub = getPublicKey();
            String data = subscriptionID;
            byte[] byteData = System.Text.Encoding.UTF8.GetBytes(data);
            byte[] byteKey = System.Text.Encoding.UTF8.GetBytes(pub);
            HMACSHA1 hmac = new HMACSHA1(byteKey);
            String publicDigest = Convert.ToBase64String(hmac.ComputeHash(byteData));
            publicDigest = publicDigest.Replace("\n", "");
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("<input type=\"hidden\" name=\"paySubscriptionCreateReply_subscriptionID\" value=\"");
            sb.Append(subscriptionID);
            sb.Append("\">\n<input type=\"hidden\" name=\"paySubscriptionCreateReply_subscriptionIDPublicSignature\" value=\"");
            sb.Append(publicDigest);
            sb.Append("\">\n");
            Response.Write(sb.ToString());
        }
        catch (Exception e)
        {
            Response.Write(e.StackTrace.ToString());
        }
    }

    public Boolean verifyTransactionSignature(System.Web.HttpRequest map)
    {
        String transactionSignature;
        String[] signedFieldsArr;
        try
        {
            transactionSignature = map.Form.Get("transactionSignature");
            signedFieldsArr = map.Form.Get("signedFields").Split(',');
        }
        catch (Exception e)
        {
            return false;
        }
        System.Text.StringBuilder data = new System.Text.StringBuilder();
        for (int i = 0; i < signedFieldsArr.Length; i++)
        {            
            data.Append(map.Form.Get(signedFieldsArr[i]));
        }
        byte[] byteData = System.Text.Encoding.UTF8.GetBytes(data.ToString());
        byte[] byteKey = System.Text.Encoding.UTF8.GetBytes(getPublicKey());
        HMACSHA1 hmac = new HMACSHA1(byteKey);
        String publicDigest = Convert.ToBase64String(hmac.ComputeHash(byteData));
        if (transactionSignature.Equals(publicDigest))
            return true;
        else
            return false;
    }
}