Imports System
Imports System.Configuration
Imports System.Net
Imports System.Security.Cryptography

Partial Class CyberSourceVB
    Inherits System.Web.UI.Page

    Function getMerchantID() As String
        'insert your own value
        Return ""
    End Function

    Function getPublicKey() As String
        'insert your own value
        Return ""
    End Function

    Function getSerialNumber() As String
        'insert your own value
        Return ""
    End Function

    'function deprecated
    Function insertSignature(ByVal amount As String, ByVal currency As String) As String
        insertSignature3(amount, currency, "authorization")
        Return "1"
    End Function

    Function insertSignature3(ByVal amount As String, ByVal currency As String, ByVal orderPage_transactionType As String) As String
        Try
            Dim timeSpanTime As TimeSpan = DateTime.UtcNow - New DateTime(1970, 1, 1)
            Dim arrayTime() As String = timeSpanTime.TotalMilliseconds.ToString().Split(".")
            Dim time As String = arrayTime(0)
            Dim merchantID As String = getMerchantID()
            If merchantID.Equals("") Then
                Response.Write("<b>Error:</b> <br>The current security script (HOP.vb) doesn't contain your merchant information. Please login to the <a href='https://ebc.cybersource.com/ebc/hop/HOPSecurityLoad.do'>CyberSource Business Center</a> and generate one before proceeding further. Be sure to replace the existing HOP.vb with the newly generated HOP.vb.<br><br>")
            End If

            Dim data As String = merchantID + amount + currency + time + orderPage_transactionType
            Dim pub As String = getPublicKey()
            Dim serialNumber As String = getSerialNumber()
            Dim byteData() As Byte = System.Text.Encoding.UTF8.GetBytes(data)
            Dim byteKey() As Byte = System.Text.Encoding.UTF8.GetBytes(pub)
            Dim hmac As HMACSHA1 = New HMACSHA1(byteKey)
            Dim publicDigest As String = Convert.ToBase64String(hmac.ComputeHash(byteData))
            publicDigest = publicDigest.Replace("\n", "")
            Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder()
            sb.Append("<input type='hidden' name='amount' value='")
            sb.Append(amount)
            sb.Append("'><input type='hidden' name='currency' value='")
            sb.Append(currency)
            sb.Append("'><input type='hidden' name='orderPage_timestamp' value='")
            sb.Append(time)
            sb.Append("'><input type='hidden' name='merchantID' value='")
            sb.Append(merchantID)
            sb.Append("'><input type='hidden' name='orderPage_transactionType' value='")
            sb.Append(orderPage_transactionType)
            sb.Append("'><input type='hidden' name='orderPage_signaturePublic' value='")
            sb.Append(publicDigest)
            sb.Append("'><input type='hidden' name='orderPage_version' value='4'>")
            sb.Append("<input type='hidden' name='orderPage_serialNumber' value='")
            sb.Append(serialNumber)
            sb.Append("'>")
            Response.Write(sb.ToString())
        Catch e As Exception
            Response.Write(e.StackTrace.ToString())
        End Try
        Return "1"
    End Function

    Function insertSubscriptionSignature(ByVal subscriptionAmount As String, ByVal subscriptionStartDate As String, ByVal subscriptionFrequency As String, ByVal subscriptionNumberOfPayments As String, ByVal subscriptionAutomaticRenew As String) As String
        Try
            Dim data As String = subscriptionAmount + subscriptionStartDate + subscriptionFrequency + subscriptionNumberOfPayments + subscriptionAutomaticRenew
            Dim pub As String = getPublicKey()
            Dim byteData() As Byte = System.Text.Encoding.UTF8.GetBytes(data)
            Dim byteKey() As Byte = System.Text.Encoding.UTF8.GetBytes(pub)
            Dim HMAC As HMACSHA1 = New HMACSHA1(byteKey)
            Dim publicDigest As String = Convert.ToBase64String(HMAC.ComputeHash(byteData))
            publicDigest = publicDigest.Replace("\n", "")
            Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder()
            sb.Append("<input type='hidden' name='recurringSubscriptionInfo_amount' value='")
            sb.Append(subscriptionAmount)
            sb.Append("'>\n<input type='hidden' name='recurringSubscriptionInfo_numberOfPayments' value='")
            sb.Append(subscriptionNumberOfPayments)
            sb.Append("'>\n<input type='hidden' name='recurringSubscriptionInfo_frequency' value='")
            sb.Append(subscriptionFrequency)
            sb.Append("'>\n<input type='hidden' name='recurringSubscriptionInfo_automaticRenew' value='")
            sb.Append(subscriptionAutomaticRenew)
            sb.Append("'>\n<input type='hidden' name='recurringSubscriptionInfo_startDate' value='")
            sb.Append(subscriptionStartDate)
            sb.Append("'>\n<input type='hidden' name='recurringSubscriptionInfo_signaturePublic' value='")
            sb.Append(publicDigest)
            sb.Append("'>\n")
            Response.Write(sb.ToString())
        Catch e As Exception
            Response.Write(e.StackTrace.ToString())
        End Try
        Return "1"
    End Function

    Function insertSubscriptionIDSignature(ByVal subscriptionID As String) As String
        Try
            Dim pub As String = getPublicKey()
            Dim data As String = subscriptionID
            Dim byteData() As Byte = System.Text.Encoding.UTF8.GetBytes(data)
            Dim byteKey() As Byte = System.Text.Encoding.UTF8.GetBytes(pub)
            Dim HMAC As HMACSHA1 = New HMACSHA1(byteKey)
            Dim publicDigest As String = Convert.ToBase64String(HMAC.ComputeHash(byteData))
            publicDigest = publicDigest.Replace("\n", "")
            Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder()
            sb.Append("<input type='hidden' name='paySubscriptionCreateReply_subscriptionID' value='")
            sb.Append(subscriptionID)
            sb.Append("'>\n<input type='hidden' name='paySubscriptionCreateReply_subscriptionIDPublicSignature' value='")
            sb.Append(publicDigest)
            sb.Append("'>\n")
            Response.Write(sb.ToString())
        Catch e As Exception
            Response.Write(e.StackTrace.ToString())
        End Try
        Return "1"
    End Function

    Function verifyTransactionSignature(ByVal map As System.Web.HttpRequest) As Boolean
        Dim transactionSignature As String
        Dim signedFieldsArr As String()
        Try
            transactionSignature = map.Form.Get("transactionSignature")
            signedFieldsArr = map.Form.Get("signedFields").Split(",")
        Catch e As Exception
            Return False
        End Try
        Dim data As System.Text.StringBuilder = New System.Text.StringBuilder()
        Dim i As Integer = 0
        While i < signedFieldsArr.Length
            data.Append(map.Form.Get(signedFieldsArr(i)))
            i = i + 1
        End While
        Dim byteData As Byte() = System.Text.Encoding.UTF8.GetBytes(data.ToString())
        Dim byteKey As Byte() = System.Text.Encoding.UTF8.GetBytes(getPublicKey())
        Dim HMAC As HMACSHA1 = New HMACSHA1(byteKey)
        Dim publicDigest As String = Convert.ToBase64String(HMAC.ComputeHash(byteData))
        If (transactionSignature.Equals(publicDigest)) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
